Index: palm/trunk/SOURCE/CURRENT_MODIFICATIONS
===================================================================
--- palm/trunk/SOURCE/CURRENT_MODIFICATIONS	(revision 56)
+++ palm/trunk/SOURCE/CURRENT_MODIFICATIONS	(revision 57)
@@ -1,8 +1,14 @@
 New:
 ---
+
+particle reflection from vertical walls implemented, particle SGS model adjusted to walls
 
 Wall functions for vertical walls now include diabatic conditions. New subroutines wall_fluxes, wall_fluxes_e. New 4D-array rif_wall.
 
 new d3par-parameter netcdf_64bit_3d to switch on 64bit offset only for 3D files
+
+new inipar-parameter pt_refrence. If given, this value is used as the reference that in buoyancy terms (otherwise, the instantaneous horizontally averaged temperature is used).
+
+new user interface user_advec_particles
 
 new initializing action "by_user" calls user_init_3d_model and allows the initial setting of all 3d arrays
@@ -12,5 +18,7 @@
 samples added to the user interface which show how to add user-define time series quantities.
 
-Makefile, check_open, check_parameters, header, init_3d_model, modules, netcdf, parin, user_interface
+unit 9 opened for debug output (file DEBUG_<pe#>)
+
+Makefile, advec_particles, buoyancy, check_open, check_parameters, diffusion_e, diffusion_u, diffusion_v, diffusion_w, diffusivities, header, init_particles, init_3d_model, modules, netcdf, parin, production_e, read_var_list, user_interface, write_var_list
 
 New: wall_fluxes
@@ -19,4 +27,5 @@
 Changed:
 -------
++age_m in particle_type
 
 Move call of user_actions( 'after_integration' ) below increment of times
@@ -27,5 +36,7 @@
 Initial velocities at nzb+1 are regarded for volume flow control in case they have been set zero before (to avoid small timesteps); see new internal parameters u/v_nzb_p1_for_vfc.
 
-check_parameters, data_output_ts, flow_statistics, init_3d_model, modules, parin, time_integration
+__vtk directives removed from main program.
+
+check_parameters, data_output_ts, flow_statistics, init_particles, init_3d_model, modules, palm, parin, time_integration
 
 
@@ -35,7 +46,9 @@
 Bugfix: preset of tendencies te_em, te_um, te_vm in init_1d_model
 
+Bugfix in sample for reading user defined data from restart file (user_init)
+
 in Makefile, default suffixes removed from the suffix list to avoid calling of m2c in
 # case of .mod files
 
 Makefile
-init_1d_model
+init_1d_model, user_interface
Index: palm/trunk/SOURCE/advec_particles.f90
===================================================================
--- palm/trunk/SOURCE/advec_particles.f90	(revision 56)
+++ palm/trunk/SOURCE/advec_particles.f90	(revision 57)
@@ -4,4 +4,7 @@
 ! Actual revisions:
 ! -----------------
+! Particle reflection at vertical walls (by Jin Zhang), regarding vertical
+! walls in the SGS model,
+! + user interface user_advec_particles
 ! TEST: PRINT statements on unit 9 (commented out)
 !
@@ -37,116 +40,4 @@
 ! sub-timesteps (if sgs velocities are included), +3d-arrays de_dx/y/z,
 ! izuf renamed iran, output of particle time series
-!
-! Revision 1.28  2006/02/23 09:41:21  raasch
-! Only a fraction of the particles may have tails, therefore output for unit
-! 85 and 90 has changed,
-! sorting of particles in gridbox order after each timestep, optimization of
-! the droplet growth by collision,
-! 0.5 replaced by 0.4999999999 in setting the random fluctuations,
-! psl, psr, pdx, etc. are now 1d arrays, i.e. they depend on the particle group,
-! improve particle release at PE boundaries, nt_anz renamed
-! current_timestep_number, idum (particle_type) renamed tail_id,
-! error number argument for handle_netcdf_error,
-!
-! Revision 1.27  2005/10/20 14:04:15  raasch
-! droplet growth by collision completed (still has to be optimized for speed),
-! new routine collision_efficiency (see end of this file),
-! 2*r replaced by r in the exponential terms (momentum equation for particles),
-! number of particles really used is additionally output on the netcdf particle
-! data file,
-! test print statement removed
-!
-! Revision 1.26  2005/06/26 19:50:14  raasch
-! Cloud droplet features added, radius is used instead of diameter,
-! particle type initial data assignment extended,
-! output on unit 80 for non-parallel runs
-!
-! Revision 1.25  2005/05/18 14:53:11  raasch
-! Extensions for NetCDF output
-!
-! Revision 1.24  2005/04/23 08:24:58  raasch
-! Revised calculation of output time counters regarding a possible decrease of
-! the output time interval in case of restart runs
-!
-! Revision 1.23  2005/03/26 14:20:05  raasch
-! calculation of vertical particle velocity (with inertia) corrected, exp_arg
-! had a wrong sign
-!
-! Revision 1.22  2004/04/30 07:48:57  raasch
-! Particle type initial data assignment extended
-!
-! Revision 1.21  2004/01/28 15:00:48  raasch
-! Output of particle infos in subroutine allocate_prt_memory on demand only
-!
-! Revision 1.20  2003/10/29 08:38:52  raasch
-! Module random_function_mod is used, modifications for new particle group
-! feature, version number is written on binary file
-!
-! Revision 1.19  2003/03/16 09:19:32  raasch
-! Two underscores (_) are placed in front of all define-strings
-!
-! Revision 1.18  2003/03/14 13:36:31  raasch
-! Error in reflection boundary condition removed: particle speed must also
-! be inverted
-!
-! Revision 1.17  2003/03/04 11:23:20  raasch
-! Error in particle inertia part removed (exp_arg must not contain the timestep)
-! Particle velocities are also stored in particles in case of zero density ratio
-!
-! Revision 1.16  2002/09/12 12:55:29  raasch
-! Transport of particles with inertia implemented, write density_ratio to
-! restart file
-!
-! Revision 1.15  2002/06/11 12:11:56  raasch
-! Declaration of u_int_l, u_int_u, v_int_l, v_int_u added
-!
-! Revision 1.14  2002/05/02  18:46:34  18:46:34  raasch (Siegfried Raasch)
-! Horizontal velocity components for particle advection are now interpolated
-! between horizontal grid levels
-! 
-! Revision 1.13  2002/04/24  18:46:11  18:46:11  raasch (Siegfried Raasch)
-! Temporary particle-arrays trlp, trnp, trrp and trsp are now allocatable arrays
-! 
-! Revision 1.12  2002/04/16 07:44:07  raasch
-! Additional boundary conditions added, particle data for later analysis can be
-! written on file
-!
-! Revision 1.11  2001/11/09 13:38:20  raasch
-! Colour information for particle tails is stored in array
-! particle_tail_coordinates, adding information to the particle tails
-! moved after call of user_particle_attributes
-!
-! Revision 1.10  2001/08/21 08:19:48  raasch
-! Storage of particle tails, precision of vertical advection improved,
-! particle attributes (e.g. size and color) can be defined by the user
-!
-! Revision 1.9  2001/07/12 12:01:27  raasch
-! Random start positions of initial particles possible
-!
-! Revision 1.8  2001/03/29 17:27:10  raasch
-! Translation of remaining German identifiers (variables, subroutines, etc.)
-!
-! Revision 1.7  2001/02/13 10:24:00  raasch
-! Particle advection possible in case of galilei transformation
-!
-! Revision 1.6  2001/01/25 06:51:04  raasch
-! Module test_variables removed, writing of particle informations is optional
-! now
-!
-! Revision 1.5  2001/01/02 17:15:29  raasch
-! Unit 80 is immediately closed after usage every time. Particle positions
-! are written on unit 90 instead of 81 (subroutine write_particles).
-!
-! Revision 1.4  2000/12/28 12:43:54  raasch
-! Packing of particles-array is done explicitly (not by PACK-function, which
-! seems to have problems when a large number of PEs is used)
-! Missing translations included,
-! code is used only optionally (cpp-directives are added)
-!
-! Revision 1.3  2000/01/20 08:51:37  letzel
-! All comments translated into English
-!
-! Revision 1.2  1999/11/25 16:41:48  raasch
-! Indexfehler im nichtparallelen Teil korrigiert
 !
 ! Revision 1.1  1999/11/25 16:16:06  raasch
@@ -693,6 +584,47 @@
           DO  j = nys, nyn
              DO  k = nzb, nzt+1
-                de_dx(k,j,i) = sgs_wfu_part * ( e(k,j,i+1) - e(k,j,i-1) ) * ddx
-                de_dy(k,j,i) = sgs_wfv_part * ( e(k,j+1,i) - e(k,j-1,i) ) * ddy
+
+                IF ( k <= nzb_s_inner(j,i-1)  .AND.  &
+                     k  > nzb_s_inner(j,i)    .AND.  &
+                     k  > nzb_s_inner(j,i+1) )  THEN
+                   de_dx(k,j,i) = 2.0 * sgs_wfu_part * &
+                                  ( e(k,j,i+1) - e(k,j,i) ) * ddx
+                ELSEIF ( k  > nzb_s_inner(j,i-1)  .AND.  &
+                         k  > nzb_s_inner(j,i)    .AND.  &
+                         k <= nzb_s_inner(j,i+1) )  THEN
+                   de_dx(k,j,i) = 2.0 * sgs_wfu_part * &
+                                  ( e(k,j,i) - e(k,j,i-1) ) * ddx
+                ELSEIF ( k < nzb_s_inner(j,i)  .AND.  k < nzb_s_inner(j,i+1) ) &
+                THEN
+                   de_dx(k,j,i) = 0.0
+                ELSEIF ( k < nzb_s_inner(j,i-1)  .AND.  k < nzb_s_inner(j,i) ) &
+                THEN
+                   de_dx(k,j,i) = 0.0
+                ELSE
+                   de_dx(k,j,i) = sgs_wfu_part * &
+                                  ( e(k,j,i+1) - e(k,j,i-1) ) * ddx
+                ENDIF
+
+                IF ( k <= nzb_s_inner(j-1,i)  .AND.  &
+                     k  > nzb_s_inner(j,i)    .AND.  &
+                     k  > nzb_s_inner(j+1,i) )  THEN
+                   de_dy(k,j,i) = 2.0 * sgs_wfv_part * &
+                                  ( e(k,j+1,i) - e(k,j,i) ) * ddy
+                ELSEIF ( k  > nzb_s_inner(j-1,i)  .AND.  &
+                         k  > nzb_s_inner(j,i)    .AND.  &
+                         k <= nzb_s_inner(j+1,i) )  THEN
+                   de_dy(k,j,i) = 2.0 * sgs_wfv_part * &
+                                  ( e(k,j,i) - e(k,j-1,i) ) * ddy
+                ELSEIF ( k < nzb_s_inner(j,i)  .AND.  k < nzb_s_inner(j+1,i) ) &
+                THEN
+                   de_dy(k,j,i) = 0.0
+                ELSEIF ( k < nzb_s_inner(j-1,i)  .AND.  k < nzb_s_inner(j,i) ) &
+                THEN
+                   de_dy(k,j,i) = 0.0
+                ELSE
+                   de_dy(k,j,i) = sgs_wfv_part * &
+                                  ( e(k,j+1,i) - e(k,j-1,i) ) * ddy
+                ENDIF
+
              ENDDO
           ENDDO
@@ -703,16 +635,18 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb+2, nzt-1
+
+             DO  k = nzb_s_inner(j,i)+2, nzt-1
                 de_dz(k,j,i) = 2.0 * sgs_wfw_part * &
                                ( e(k+1,j,i) - e(k-1,j,i) ) / ( zu(k+1)-zu(k-1) )
              ENDDO
-             de_dz(nzb,j,i)   = 0.0
-             de_dz(nzb+1,j,i) = 2.0 * sgs_wfw_part *              &
-                                ( e(nzb+2,j,i) - e(nzb+1,j,i) ) / &
-                                ( zu(nzb+2) - zu(nzb+1) )
+
+             k = nzb_s_inner(j,i)
+             de_dz(nzb:k,j,i)   = 0.0
+             de_dz(k+1,j,i) = 2.0 * sgs_wfw_part * ( e(k+2,j,i) - e(k+1,j,i) ) &
+                                                 / ( zu(k+2) - zu(k+1) )
              de_dz(nzt,j,i)   = 0.0
              de_dz(nzt+1,j,i) = 0.0
           ENDDO
-       ENDDO              
+       ENDDO
 
 !
